# APRIORI_PYTHON_HEADER_START#################################################
#                                                          vi: set ts=8: sw=4:
# @(#) $Id: __init__.py,v 1.2 2003/10/01 14:36:09 th Exp $
#
# RestartWithLink -- add some comfort to the Zope restart process
# ----------------------------------------------------------------------------
# Copyright (C) 2003  APRIORI business solutions AG
#                     http://www.apriori.de
# ----------------------------------------------------------------------------
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# 
# $Log: __init__.py,v $
# Revision 1.2  2003/10/01 14:36:09  th
# first copylefted version
#
#
# APRIORI_PYTHON_HEADER_END###################################################

import sys
if hasattr(sys, 'ZMANAGED'):
    import zLOG, Globals
    from AccessControl import getSecurityManager

    def get_restart_timeout(self):
        """
        overwrite this function to return another value
        if you like
        """
        return 5

    def manage_restart(self, URL1):
        """Shut down the application"""
        try:
            user = '"%s"' % getSecurityManager().getUser().getUserName()
        except:
            user = 'unknown user'
        zLOG.LOG("ApplicationManager", zLOG.INFO,
                 "Restart requested by %s" % user)
        for db in Globals.opened: db.close()
        raise SystemExit, """<html>
        <head><meta HTTP-EQUIV=REFRESH CONTENT="%(timeout)d; URL=%(url1)s/manage_main">
        </head>
        <body><h1>Zope is restarting...</h1>
        <p>
<script type="text/javascript"><!--
function f00(num) {
    if (num < 10) {
      return '0'+num
    } else {
      return num
    }
}
now = new Date();
document.write('(at '+now.getHours()+':'+f00(now.getMinutes())+':'+f00(now.getSeconds())+')');
//--></script>
        ... and the browser will try to refresh
        after a period of %(timeout)d seconds.</p><p>
        You may:<ul><li>
        click <a href="%(url1)s/manage_main">here</a>
        to try the refresh manually (and get the Control Panel again)</li>
        <li>request Zope to <a href="%(url1)s/manage_restart">restart</a> again</li>
        <li><a href="%(url1)s/Products/manage_main?skey=%(bobo)s&rkey=%(bobo)s">here</a>
        to get the products view, sorted by change time</li></ul>
        </p></body></html>
        """ % { 'url1': URL1,
                'bobo': 'bobobase_modification_time',
                'timeout': self.get_restart_timeout()
               }
        sys.exit(1)

    from App.ApplicationManager import ApplicationManager
    ApplicationManager.manage_restart = manage_restart
    ApplicationManager.get_restart_timeout = get_restart_timeout

